#include "mainwindow.h"
#include "ui_mainwindow.h"

const int m = 60;
const int n = 2*m+1;

bool isPrime (int number)
{
    if (number == 1)
        return false;
    for (int i = 2; i*i <= number; i++)
    {
      if (number % i == 0)
        return false;
    }
    return true;
}

void MainWindow::obarvi ()
{
    for (int i = 1; i <=n*n; i++)
    {
        QColor c;
        if (isPrime (i))
           c = QColor ("red");
        else
            c = QColor ("white");
        map[i]->setBackgroundColor (c);
    }
}



void MainWindow::place (int r, int s, int i, int k)
{
    QTableWidgetItem * item = new QTableWidgetItem;
    ui->tableWidget->setItem (r, s, item);
    item->setText (QString::number (i));
    item->setToolTip (QString::number (i));

    QColor c = QColor::fromHsv ((k*45)%360, 255, 255);
    item->setBackgroundColor(c);

    map [i] = item;
}

void MainWindow::setup ()
{
    ui->tableWidget->setColumnCount (n);
    ui->tableWidget->setRowCount (n);
    int h = ui->tableWidget->rowHeight (0) /* * 3 /2 */;
    h = 4;
    for (int c = 0; c<n; c++)
        ui->tableWidget->setColumnWidth (c, h);
    for (int c = 0; c<n; c++)
        ui->tableWidget->setRowHeight (c, h);

    int i = 1;
    int r = m; // stred je (r,s), cislovany od 0
    int s = m;

    place (r, s, i++, 1); // jednicka
    s++;

    for (int k = 2; k <= 2; k++)
    {
        int j;
        for (j = 1; j<=k; j++) place (r++, s, i++, k); // dolu
        r--; s--;
        for (j = 1; j<=2*k-2; j++) place (r, s--, i++, k); // vlevo
        s++; r--;
        for (j = 1; j<=2*k-2; j++) place (r--, s, i++, k); // nahoru
        r++; s++;
        for (j = 1; j<=2*k-2; j++) place (r, s++, i++, k); // vpravo
        s--;r++;
        for (j = 1; j<=k-2; j++)  place (r, s++, i++, k); // dolu
        s++;r--;
    }

    for (int k = 3; k <= m+1; k++)
    {
        int j;
        for (j = 1; j<=2*k-2; j++) place (r++, s, i++, k); // dolu
        r--; s--;
        for (j = 1; j<=2*k-2; j++) place (r, s--, i++, k); // vlevo
        s++; r--;
        for (j = 1; j<=2*k-2; j++) place (r--, s, i++, k); // nahoru
        r++; s++;
        for (j = 1; j<=2*k-2; j++) place (r, s++, i++, k); // vpravo
    }
}

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    test ();
    setup ();
    obarvi();

}


#include <QGraphicsLineItem>

void MainWindow::test()
{
    QGraphicsScene * s = new QGraphicsScene;
    ui->graphicsView->setScene(s);

    s->addRect(0, 0, 100, 200);

    QGraphicsLineItem * a = new QGraphicsLineItem;
    a->setLine(10, 10, 300, 100);
    a->setPen(QColor ("red"));
    s->addItem(a);

    QPixmap * b = new QPixmap(100, 100);
    b->fill(QColor ("yellow"));

    QPainter c (b);
    c.setPen(QColor ("green"));
    c.drawLine(10, 10, 40, 40);

    QGraphicsPixmapItem * p = new QGraphicsPixmapItem;
    p->setPixmap(*b);
    p->setFlags(QGraphicsItem::ItemIsSelectable|
                QGraphicsItem::ItemIsMovable);
    s->addItem(p);

}

MainWindow::~MainWindow()
{
    delete ui;
}
